	/* Yacc specification of calculator  */
	/* Figure 4.58, Aho, 2nd ed., pg 289 */

%{
#include <stdio.h>
#include <ctype.h>
%}

%token DIGIT

%%

line	: expr '\n'	{ printf("%d\n",$1);}
	; /* allows printing of the result */
expr	: expr '+' term	{ $$ = $1 + $3;}
	| term	        { $$ = $1;}
	;
term	: term '*' factor { $$ = $1 * $3; }
	| factor	{ $$ = $1;}
    	;
factor	: DIGIT		{ $$ = $1; }
      	| '(' expr ')'	{ $$ = $2; }
	;
%%
main()
{ return yyparse();
}

int yylex(void)
{ int c;
  c = getchar();
  if ( isdigit(c) ) {
    yylval = c - '0';
    return DIGIT;
  }
  /* if (c == '\n') return 0;*/
  /* makes the parse stop */
  return c;
}

